/*
This is a Example program to retrieve and display the data. 
Press the Run button on the right of the screen (described the behavior of the Example program below). 
Please create a new application rewrite this program work. 
*/

/*
suko id    = rdf1s2261i
Tsubame id = rdf1s7545i
*/

/*
2018/11/26
位置の反映はできたのであとは円を地図に反映させよう！
参考
https://lab.syncer.jp/Web/API/Google_Maps/JavaScript/#section-10
サブ的情報は元のAED座標で済ませればいいと思う
*/

var all_data;        
function initialize(){
	all_data = new Array();
	// データをLinkDataから取得 
	tmp_a_data = new Array();
	
	$.each(LinkData.getWorks(), function(workKey, workValue) {
		//$("#result").append("<h3>Work: " + workValue + "</h3>");
		$.each(LinkData.getFiles(workValue), function(fileKey, fileValue) {
			$.each(LinkData.getSubjects(workValue, fileValue), function(subjKey, subjValue) {
				var tmp_data = {}
				tmp_data["id"] = subjValue;
				$.each(LinkData.getProperties(workValue, fileValue), function(propKey, propValue) {
					$.each(LinkData.getObjects(workValue, fileValue, subjValue, propValue), function(objKey, objValue) {
						if(propValue == "http://linkdata.org/property/rdf1s7545i#" + encodeURIComponent("設置場所")){
							tmp_data["name"] = objValue;
						}else if(propValue == "http://linkdata.org/property/rdf1s7545i#" + encodeURIComponent("住所")){
							tmp_data["location"] = objValue;
						}else if(propValue == "http://www.w3.org/2003/01/geo/wgs84_pos#lat"){
							tmp_data["lat"] = objValue;
						}else if(propValue == "http://www.w3.org/2003/01/geo/wgs84_pos#long"){
							tmp_data["longitude"] = objValue;
						}else if(propValue == "http://linkdata.org/property/rdf1s7545i#" + encodeURIComponent("電話番号")){
							tmp_data["tel"] = objValue;
						}else if(propValue == "http://linkdata.org/property/rdf1s7545i#UpdateDate"){
							tmp_data["date"] = new Date(objValue);
						}
					});
				});
				tmp_a_data.push(tmp_data);
			});
		});
	});
	
	//全データ
	all_data = tmp_a_data;
	
	//全データを地図上に表示

    // 地図センター緯度経度の初期値は「燕市役所」
    var latlng = new google.maps.LatLng(37.673208, 138.882459);
    
    var myOptions = {
    zoom: 12,
    center: latlng,
    mapTypeId: google.maps.MapTypeId.ROADMAP
    };
    var map = new google.maps.Map(document.getElementById("result"), myOptions);
	

	// ウィンドウに表示するデータをつくる

	var data = new Array();
	for (var i in all_data){ 
        var value = all_data[i].name;  
        data.push({position: new google.maps.LatLng(all_data[i].lat, all_data[i].longitude), content: all_data[i].name + '<br>【所在地】' + all_data[i].location + '<br>【電話番号】'+"<a href=tel:" + all_data[i].tel + ">" + all_data[i].tel + "</a>"+'<br>'+"<a href='http://www.aed-life.com/information/use.html'" + "target='_blank'>" +'応急手当の手順（AED公式サイト）' + "</a>" + "<br>　" + all_data[i].date.getFullYear() + "年" + (all_data[i].date.getMonth()+1) + "月" + all_data[i].date.getDate() + "日時点（未実装）"
        });
	};     
/*
	//円データの描写テスト（市役所に円を描写：正常に動作）
	var circle = new google.maps.Circle( {
	map: map ,
	center: new google.maps.LatLng( all_data[55].lat, all_data[55].longitude ) ,
	radius: 80 ,
	fillColor: "aqua",
	fillOpacity: 0.12,
	strokeWeight: 0.5
} ) ;
*/

	// Markerを地図上にウィンドウで表示
    for (i = 0; i < data.length; i++) {
         var marker = new google.maps.Marker({
            position: data[i].position,
            map: map,
            icon: 'http://app.linkdata.org/asset/92cc5fd5.png',

        });
        attachMessage(marker, data[i].content);
		/*Circleをここに挟んでみる（上限）成功*/
		var circle = new google.maps.Circle({
		map: map ,	
		center: new google.maps.LatLng( all_data[i].lat, all_data[i].longitude ) ,	
		radius: 900 ,//半径を弄れるようにする(生存率10％低下につき徒歩半径距離40m/分、走る半径距離120m/分)
		fillColor: "aqua",
		fillOpacity: 0.12,
		strokeWeight: 0.5
		});
		/*Circleをここに挟んでみる（下限）*/
    };
};


// 地図のマーカーをクリックするとウィンドウを表示する処理
function attachMessage(marker, msg) {
	google.maps.event.addListener(marker, 'click', function(event) {
    	new google.maps.InfoWindow({
			content: msg
        }).open(marker.getMap(), marker);
    });
};

/*地図の円はなぜかクリックできず。マーカーで済ませる*/

window.onload = function() {
    $(function(){
    	initialize();        
    });	
};


